aboutsummaryrefslogtreecommitdiff
path: root/test/lint
diff options
context:
space:
mode:
authorflack <flack@contentcontrol-berlin.de>2021-02-06 19:58:28 +0100
committerflack <flack@contentcontrol-berlin.de>2021-02-13 09:57:50 +0100
commit3f8776a1391c3978ed66144df15fd9bcb9edd35d (patch)
tree78ccc7ef1327c4e8269fdd328a72da8ed08990ce /test/lint
parent6c6140846f37de8c132b3b6abf09f3d7940554a7 (diff)
downloadbitcoin-3f8776a1391c3978ed66144df15fd9bcb9edd35d.tar.xz
Re-add dead code detection
Diffstat (limited to 'test/lint')
-rwxr-xr-xtest/lint/lint-python-dead-code.sh23
1 files changed, 23 insertions, 0 deletions
diff --git a/test/lint/lint-python-dead-code.sh b/test/lint/lint-python-dead-code.sh
new file mode 100755
index 0000000000..c3b6ff3c98
--- /dev/null
+++ b/test/lint/lint-python-dead-code.sh
@@ -0,0 +1,23 @@
+#!/usr/bin/env bash
+#
+# Copyright (c) 2021 The Bitcoin Core developers
+# Distributed under the MIT software license, see the accompanying
+# file COPYING or http://www.opensource.org/licenses/mit-license.php.
+#
+# Find dead Python code.
+
+export LC_ALL=C
+
+if ! command -v vulture > /dev/null; then
+ echo "Skipping Python dead code linting since vulture is not installed. Install by running \"pip3 install vulture\""
+ exit 0
+fi
+
+# --min-confidence 100 will only report code that is guaranteed to be unused within the analyzed files.
+# Any value below 100 introduces the risk of false positives, which would create an unacceptable maintenance burden.
+if ! vulture \
+ --min-confidence 100 \
+ $(git ls-files -- "*.py"); then
+ echo "Python dead code detection found some issues"
+ exit 1
+fi